---
title: Confirm Device Activation Code
description: The POST /{{envID}}/flows/{{flowID}} operation confirms the user code generated by the device authorization request. The user is prompted in the flow to provide the user code (which the user sees in the flow UI as the device activation code). This operation uses the application/vnd.pingidentity.deviceAuthGrant.userCode.verify+json custom media type as the content type in the request header.
component: pingone-api
page_id: pingone-api:auth:flows/device-authorization-grant-flows/confirm-device-activation-code
canonical_url: https://developer.pingidentity.com/pingone-api/auth/flows/device-authorization-grant-flows/confirm-device-activation-code.html
section_ids:
  prerequisites: Prerequisites
  headers: Headers
  body: Body
  example-request: Example Request
---

# Confirm Device Activation Code

##

```none
POST {{authPath}}/{{envID}}/flows/{{flowID}}
```

The `POST /{{envID}}/flows/{{flowID}}` operation confirms the user code generated by the device authorization request. The user is prompted in the flow to provide the user code (which the user sees in the flow UI as the device activation code). This operation uses the `application/vnd.pingidentity.deviceAuthGrant.userCode.verify+json` custom media type as the content type in the request header.

### Prerequisites

* Send an authorize request to get a user code: [Device Authorization](../../openid-connect-oauth-2/device-authorization-grant.html).

* Refer also to the `DAG_USER_CODE_REQUIRED` flow state in the [Flow status values table](../flows-1.html).

> **Collapse: Request Model**
>
> | Property   | Type   | Required? |
> | ---------- | ------ | --------- |
> | `userCode` | String | Required  |
>
> Refer to the [Flows](../flows-1.html) for full property descriptions.

### Headers

Content-Type      application/vnd.pingidentity.deviceAuthGrant.userCode.verify+json

### Body

raw ( application/vnd.pingidentity.deviceAuthGrant.userCode.verify+json )

```json
{
    "userCode": "{{userCode}}"
}
```

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff '{{authPath}}/{{envID}}/flows/{{flowID}}' \
--header 'Content-Type: application/vnd.pingidentity.deviceAuthGrant.userCode.verify+json' \
--data '{
    "userCode": "{{userCode}}"
}'
```

```csharp
var options = new RestClientOptions("{{authPath}}/{{envID}}/flows/{{flowID}}")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("Content-Type", "application/vnd.pingidentity.deviceAuthGrant.userCode.verify+json");
var body = @"{" + "\n" +
@"    ""userCode"": ""{{userCode}}""" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{authPath}}/{{envID}}/flows/{{flowID}}"
  method := "POST"

  payload := strings.NewReader(`{
    "userCode": "{{userCode}}"
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/vnd.pingidentity.deviceAuthGrant.userCode.verify+json")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
POST /{{envID}}/flows/{{flowID}} HTTP/1.1
Host: {{authPath}}
Content-Type: application/vnd.pingidentity.deviceAuthGrant.userCode.verify+json

{
    "userCode": "{{userCode}}"
}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/vnd.pingidentity.deviceAuthGrant.userCode.verify+json");
RequestBody body = RequestBody.create(mediaType, "{\n    \"userCode\": \"{{userCode}}\"\n}");
Request request = new Request.Builder()
  .url("{{authPath}}/{{envID}}/flows/{{flowID}}")
  .method("POST", body)
  .addHeader("Content-Type", "application/vnd.pingidentity.deviceAuthGrant.userCode.verify+json")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{authPath}}/{{envID}}/flows/{{flowID}}",
  "method": "POST",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/vnd.pingidentity.deviceAuthGrant.userCode.verify+json"
  },
  "data": JSON.stringify({
    "userCode": "{{userCode}}"
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'POST',
  'url': '{{authPath}}/{{envID}}/flows/{{flowID}}',
  'headers': {
    'Content-Type': 'application/vnd.pingidentity.deviceAuthGrant.userCode.verify+json'
  },
  body: JSON.stringify({
    "userCode": "{{userCode}}"
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests
import json

url = "{{authPath}}/{{envID}}/flows/{{flowID}}"

payload = json.dumps({
  "userCode": "{{userCode}}"
})
headers = {
  'Content-Type': 'application/vnd.pingidentity.deviceAuthGrant.userCode.verify+json'
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{authPath}}/{{envID}}/flows/{{flowID}}');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/vnd.pingidentity.deviceAuthGrant.userCode.verify+json'
));
$request->setBody('{\n    "userCode": "{{userCode}}"\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "json"
require "net/http"

url = URI("{{authPath}}/{{envID}}/flows/{{flowID}}")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["Content-Type"] = "application/vnd.pingidentity.deviceAuthGrant.userCode.verify+json"
request.body = JSON.dump({
  "userCode": "{{userCode}}"
})

response = http.request(request)
puts response.read_body
```

```swift
let parameters = "{\n    \"userCode\": \"{{userCode}}\"\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{authPath}}/{{envID}}/flows/{{flowID}}")!,timeoutInterval: Double.infinity)
request.addValue("application/vnd.pingidentity.deviceAuthGrant.userCode.verify+json", forHTTPHeaderField: "Content-Type")

request.httpMethod = "POST"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```
